program e8asy(input,output);
{EDUC-8 assembler.
 Program author: Steven S. Pietrobon (25 Jan 2008)
  8 Feb 2008: First release
 24 Apr 2009: Added initial constant for variables
              Fixed referencing to arrays or tables within same page}

const  version = 1.01;
       date = '24 Apr 2009';
       npage = 16;
       nword = 16;
       n = npage*nword;
       idlength = 12;
       instrlength = 17;
       oplength = 4;
       commentlength = 80 - idlength - instrlength - oplength;

label 999;

type stringtype = (instrs,vc,arrays,vars,consts,id,instr,opcode,comment);
     shortstring = string[commentlength];
     linetype = array[id..comment] of shortstring;
     arraytype = array[0..n-1] of linetype;
     postype = array[0..npage-1] of integer;

var infile,outfile:text;
    cnt:array[vars..consts] of integer;
    word:array[instrs..arrays] of postype;
    ca,constpos:postype;
    pagelow,pagehigh:integer;
    filename:string;
    l:array[instrs..consts] of arraytype;

function i2o(i:integer):shortstring;
{Converts an integer to 737 octal}
var it:integer;
    s,st:shortstring;
begin{i2o}
  if i >=0
    then it := i
    else it := n+i;
  str((it mod 8):1,s);
  st := s;
  it := it div 8;
  str((it mod 4):1,s);
  st := s+st;
  it := it div 4;
  str((it mod 8):1,s);
  i2o := s+st;
end;{i2o}

function c2o(s:shortstring):shortstring;
{Converts constant to opcode}
var fl:char;
    code,temp,I:integer;
begin{c2o}
  fl := s[1];
  case fl of
    '#': c2o := copy(s,2,3);
    '+','-','0'..'9': begin{numerical constant}
                        val(s,temp,code);
                        c2o := i2o(temp);
                      end;{numerical constant}
    '%': begin{binary}
           temp := 0;
           for I := 2 to 9 do
             temp := 2*temp+ord(s[I])-48;
           c2o := i2o(temp);
         end;{binary}
    '''': c2o := i2o(ord(s[2]));
    else c2o := '';
  end;{case}
end;{c2o}

procedure page_length_test(page:integer);
begin{page_length_test}
  if word[instrs][page] > nword then 
    begin{error}
      writeln('Error: Word count exceeded in page ',page:1,'.');
      goto 999;
    end;{error}
end;{page_length_test}

function constant(s:shortstring):boolean;
var letter:char;
begin{constant}
  letter := s[1];
  constant := (letter = '#') or (letter = '+') or (letter = '-') or
              ((letter >= '0') and (letter <= '9')) or (pos('A(',s) = 1) or
              (letter = '%') or (letter = '''');
end;{constant}

procedure read_code;
var page,temp,code,position,ll,ps,tc:integer;
    s:string;
    sl:linetype;
begin{read code}
  cnt[vars] := 0;
  cnt[consts] := 0;
  pagelow := npage-1;
  pagehigh := 0;
  page := -1;
  tc := 0;
  while not eof(infile) do
    begin{convert}
      readln(infile,s);
      ll := length(s);
      position := pos('/',s);
      if position > 0
        then begin{new comment}
               sl[comment] := copy(s,position+1,ll-position);
               val(sl[comment],temp,code);
               if (position = 1) and (code = 0) and (0 <= temp) and 
                 (temp < npage) then
                 begin{new page}
                   page := temp;
                   word[instrs][page] := 0;
                   word[arrays][page] := 0;
                   if page < pagelow 
                     then begin{new pagelow}
                            pagelow := page;
                            ca[page] := 0;
                          end{new pagelow}
                     else ca[page] := ca[page-1] + word[arrays][page-1];
                   if page > pagehigh then pagehigh := page;
                 end;{new page}
               delete(s,position,ll-position+1);
             end{new comment}
        else sl[comment] := '';
      position := pos(',',s);
      if position > 0
        then begin{new label}
               sl[id] := copy(s,1,position-1);
               delete(s,1,position);
             end{new label}
        else sl[id] := '';
      if length(s) > 0
        then begin{instr}
               repeat
                 ps := pos('  ',s);
                 if ps > 0 then delete(s,ps,1);
               until ps = 0;
               if s[1] = ' ' then 
                 delete(s,1,1);
               if s[length(s)] = ' ' then 
                 delete(s,length(s),1);
               sl[instr] := s;
             end{instr}
        else sl[instr] := '';
      if (s = 'VAR') or (pos('VAR=',s) = 1)
        then begin{new variable}
               temp := cnt[vars];
               sl[opcode] := '000';
               l[vars][temp] := sl;
               cnt[vars] := temp+1;
             end{new variable}
        else if length(s) > 0 then
               begin{non-empty line}
                 if constant(s) and (tc = 0)
                   then begin{new constant}
                          sl[opcode] := c2o(s);
                          temp := cnt[consts];
                          l[consts][temp] := sl;
                          cnt[consts] := temp+1;
                        end{new constant}
                   else if (pos('ARRAY[',s) = 1) or (pos('TABLE[',s) = 1) or
                          (tc > 0)
                          then begin{new array}
                                 sl[opcode] := '';
                                 if pos('TABLE[',s) = 1
                                   then val(copy(s,7,length(s)-7),tc,code)
                                   else if tc > 0 then 
                                          begin{new constant}
                                            sl[opcode] := c2o(s);
                                            tc := tc-1;
                                          end;{new constant}
                                 temp := ca[page]+word[arrays][page];
                                 l[arrays][temp] := sl;
                                 word[arrays][page] := word[arrays][page]+1;
                               end{new array}
                          else if page >= 0 then
                                 begin{new instr}
                                   temp := nword*page+word[instrs][page];
                                   if s = 'RTNADR'
                                     then sl[opcode] := '000'
                                     else sl[opcode] := '';
                                   l[instrs][temp] := sl;
                                   word[instrs][page] := word[instrs][page]+1;
                                   page_length_test(page);
                                 end;{new instr}
               end;{non-empty line}
    end;{convert}
end;{read code}

function notskip(p,w:integer):boolean;
{Checks to see if the previous instr is a not a skip instr}
var I:integer;
    s:string;
begin{notskip}
  if w = 0
    then I := nword*(p-1) + word[instrs][p-1]-1
    else I := nword*p+w-1;
  s := l[instrs][I][instr];
  notskip := not((pos('ISZ ',s) = 1) or (pos('SZA',s) = 1) or 
                 (pos('SMA',s) = 1) or (pos('SZA.SMA',s) = 1) or
                 (pos('SKF ',s) = 1) or (pos('SDF ',s) = 1));
end;{notskip}

function checkjump(p,w:integer):boolean;
{Checks to see if the previous instr is a JMP or HLT and the instr
 before that is not a skip instr}
var I:integer;
    s:string;
    ns:boolean;
begin{checkjump}
  if w = 0
    then begin{word 0}
           I := nword*(p-1) + word[instrs][p-1]-1;
           ns := notskip(p-1,word[instrs][p-1]-1);
         end{word 0}
    else begin{word > 0}
           I := nword*p+w-1;
           ns := notskip(p,w-1);
         end;{word > 0}
  s := l[instrs][I][instr];
  checkjump := (((pos('JMP ',s) = 1) or (pos('HLT ',s) = 1)) and ns) or
               (word[instrs][p-1] = 0);
end;{checkjump}

procedure find_constpos;
var page,I:integer;
    ends:string;
begin{find constpos}
  constpos[pagelow] := 0;
  constpos[pagehigh] := word[instrs][pagehigh];
  for page := pagelow+1 to pagehigh-1 do
    begin{set constpos}
       constpos[page] := -1;
       I := 0;
       while (constpos[page] < 0) and (I <= word[instrs][page]) do
         begin{check page}
           if checkjump(page,I) then 
             constpos[page] := I;
           I := I+1;
         end;{check page}
       if constpos[page] < 0 then
         begin{insert jump}
           I := 0;
           while (constpos[page] < 0) and (I <= word[instrs][page]) do
             begin{check page}
               if notskip(page,I) then 
                 constpos[page] := I+1;
               I := I+1;
             end;{check page}
           for I := word[instrs][page] downto constpos[page] do
             l[instrs][nword*page+I] := l[instrs][nword*page+I-1];
           word[instrs][page] := word[instrs][page]+1;
           page_length_test(page);
           I := nword*page+constpos[page];
           if l[instrs][I][id] = ''
             then begin{end label}
                     str(page:1,ends);
                     ends := 'END'+ends;
                     l[instrs][I][id] := ends;
                  end{end label}
             else ends := l[instrs][I][id];
           I := I-1;
           l[instrs][I][id] := '';
           l[instrs][I][instr] := 'JMP ' + ends;
           l[instrs][I][comment] := '';
         end;{insert jump}
    end;{set constpos}
end;{find constpos}

procedure insert_arrays_tables;
var page,np,na,I,J,K,al,code,lap,law:integer;
    s,si,sc,Ks,las:shortstring;
    sl:linetype;
    la:arraytype;
begin{insert arrays tables}
  for page := pagelow to pagehigh do
    if word[arrays][page] > 0 then    
      begin{page cycle}
        np := nword*page;
        na := ca[page];
        I := 0;
        J := 0;
        repeat
          si := l[arrays][na+I][id];
          s := l[arrays][na+I][instr];
          sc := l[arrays][na+I][comment];
          sl[id] := si;
          sl[comment] := sc;
          K := 1;
          val(copy(s,7,length(s)-7),al,code);
          if pos('ARRAY[',s) = 1
            then begin{new array}
                   sl[instr] := 'VAR';
                   sl[opcode] := '000';
                   la[J] := sl;
                   las := 'Array ';
                   sl[comment] := '';
                   J := J+1;
                   while K < al do
                     begin{new array variable}
                       str(K:1,Ks);
                       sl[id] := si + '[' + Ks + ']';
                       la[J] := sl;
                       J := J+1;
                       K := K+1;
                     end;{new array variable}
                 end{new array}
            else if pos('TABLE[',s) = 1 then
                   begin{new table}
                     I := I+1;
                     sl[instr] := l[arrays][na+I][instr];
                     sl[opcode] := l[arrays][na+I][opcode];
                     la[J] := sl;
                     las := 'Table ';
                     J := J+1;
                     sl[comment] := '';
                     while K < al do 
                       begin{new array variable}
                         I := I+1;
                         str(K:1,Ks);
                         sl[id] := si + '[' + Ks + ']';
                         sl[instr] := l[arrays][na+I][instr];;
                         sl[opcode] := l[arrays][na+I][opcode];
                         la[J] := sl;
                         J := J+1;
                         K := K+1;
                       end;{new array variable}
                   end;{new table}
          I := I+1;
        until I = word[arrays][page];

        lap := page;
        K := 0;
        repeat
          np := nword*lap;
          na := nword-word[instrs][lap];
          if J < na
            then law := J
            else law := na;
          for I := word[instrs][lap]-1 downto constpos[lap] do
            l[instrs][np+I+law] := l[instrs][np+I];
          for I := 0 to law-1 do
            l[instrs][np+constpos[lap]+I] := la[K+I];
          word[instrs][lap] := word[instrs][lap]+law;
          constpos[lap] := constpos[lap]+law;
          lap := lap+1;
          J := J-law;
          K := K+law;
          if (J > 0) and (constpos[lap] > 0) then
            begin{array error}
              writeln('Error: ',las,si,' can''t continue into page ',lap:1,'.');
              goto 999;
            end;{array error}
        until J = 0;
      end;{page cycle}
end;{insert arrays tables}

function posid(p:integer; il:stringtype; s:shortstring):integer;
var I,temp,np:integer;
begin{check id}
  temp := -1;
  np := nword*p;
  I := 0;
  while (temp < 0) and (I < word[il][p]) do
    begin{check}
      if l[il][np+I][id] = s then temp := I;
      I := I+1;
    end;{check}
  posid := temp;
end;{check id}

function posl(il:stringtype; s:shortstring):integer;
var I,temp:integer;
begin{check id}
  temp := -1;
  I := 0;
  while (temp < 0) and (I < cnt[il]) do
    begin{check}
      if l[il][I][id] = s then temp := I;
      I := I+1;
    end;{check}
  posl := temp;
end;{check id}

procedure newvc(il:stringtype; p,pl:integer);
var I,np:integer;
begin{new vc}
  np := nword*p;
  l[vc][np+word[vc][p]] := l[il][pl];
  word[vc][p] := word[vc][p]+1;
  if il = vars then
    begin{delete}
      for I := pl to cnt[il]-2 do
        l[il][I] := l[il][I+1];
      cnt[il] := cnt[il]-1;
    end;{delete}
end;{new vc}

procedure insert_indirect_variables;
var I,page,np,pl:integer;
    s:string;
begin{insert indirect variables}
  for page := pagelow to pagehigh do
    begin{check for indirect instruction}
      word[vc][page] := 0;
      np := nword*page;
      for I := 0 to word[instrs][page]-1 do
        begin{word count}
          s := l[instrs][np+I][instr];
          if pos(' I ',s) > 0 then
            begin{check id}
              delete(s,1,6);
              if (posid(page,instrs,s) < 0) and (posid(page,vc,s) < 0) then
                begin{check vars}
                  pl := posl(vars,s);
                  if pl >= 0
                    then newvc(vars,page,pl)
                    else begin{check consts}
                           pl := posl(consts,s);
                           if pl >= 0
                             then newvc(consts,page,pl)
                             else begin{No variable or constant}
                                    write('Error: No variable or constant for');
                                    writeln(' ',s,' in page ',page:1,'.');
                                    goto 999;
                                  end;{No variable or constant}
                         end;{check consts}
                end;{check vars}
            end;{check id}
        end;{word count}
    end;{check for indirect instruction}
end;{insert indirect variables}

procedure insert_variables_constants;
var I,J,page,np,pl,il,vl:integer;
    s,st:string;
    sl,blank:linetype;
begin{insert variables constants}
  blank[id] := '';
  blank[instr] := 'BLANK';
  blank[opcode] := '000';
  blank[comment] := '';
  for page := pagelow to pagehigh do
    begin{check for direct instruction}
      np := nword*page;
      for I := 0 to word[instrs][page]-1 do
        begin{word count}
          s := l[instrs][np+I][instr];
          if (pos(' I ',s) = 0) and ((pos('AND ',s) = 1) or (pos('TAD ',s) = 1)
           or (pos('ISZ ',s) = 1) or (pos('INC ',s) = 1) or (pos('DCA ',s) = 1)
           or (pos('JMS ',s) = 1) or (pos('JMP ',s) = 1)) then
            begin{check id}
              st := s;
              delete(s,1,4);
              if (posid(page,instrs,s) < 0) and (posid(page,vc,s) < 0) then
                begin{check vars}
                  pl := posl(vars,s);
                  if pl >= 0
                    then newvc(vars,page,pl)
                    else begin{check consts}
                           pl := posl(consts,s);
                           if pl >= 0
                             then newvc(consts,page,pl)
                             else begin{add indirect}
                                    insert('I ',st,5);
                                    st := st + 'A';
                                    l[instrs][np+I][instr] := st;
                                    st := s;
                                    s := s + 'A';
                                    if (posid(page,instrs,s) < 0) and 
                                       (posid(page,vc,s) < 0) then
                                      begin{add indirect address}
                                        sl[id] := s;
                                        sl[instr] := 'A(' + st + ')';
                                        sl[opcode] := '';
                                        sl[comment] := '';
                                        l[vc][np+word[vc][page]] := sl;
                                        word[vc][page] := word[vc][page]+1;
                                      end;{add indirect address}
                                  end;{add indirect}
                         end;{check consts}
                end;{check vars}
            end;{check id}
        end;{word count}
      pl := 0;
      for I := 0 to word[vc][page]-1 do
        if (l[vc][np+I][instr] = 'VAR') or 
           (pos('VAR=',l[vc][np+I][instr]) = 1) then
          begin{shift variables}
            sl := l[vc][np+I];
            for J := I downto pl+1 do
              l[vc][np+J] := l[vc][np+J-1];
            l[vc][np+pl] := sl;
            pl := pl+1;
          end;{shift variables}
      il := nword-word[instrs][page];
      vl := word[vc][page];
      if constpos[page] > 0
        then for I := vl to il-1 do
               l[vc][np+I] := blank
        else begin{insert before}
               for I := vl-1 downto 0 do
                 l[vc][np+il-vl+I] := l[vc][np+I];
               for I := 0 to il-vl-1 do
                 l[vc][np+I] := blank;
             end;{insert before}
      word[vc][page] := nword-word[instrs][page];
      for I := word[instrs][page]-1 downto constpos[page] do
        l[instrs][np+I+word[vc][page]] := l[instrs][np+I];
      for I := 0 to word[vc][page]-1 do
        l[instrs][np+constpos[page]+I] := l[vc][np+I];
      word[instrs][page] := word[instrs][page]+word[vc][page];
      page_length_test(page);
      constpos[page] := constpos[page]+word[vc][page];
    end;{check for direct instruction}
  np := nword*pagehigh;
  I := nword;
  while (l[instrs][np+I-1][instr] = 'BLANK') and (I > 0) do I := I-1;
  word[instrs][pagehigh] := I;
end;{insert variables constants}

procedure insert_opcodes;
var s,si,st,oc:shortstring;
    I,J,la,np,page,Ip,ad:integer;
    a:arraytype;
begin{insert opcodes}
  la := 0;
  for I := nword*pagelow to nword*(pagehigh+1)-1 do
    begin{find new label}
      s := l[instrs][I][id];
      if (length(s) > 0) and (pos('A(',l[instrs][I][instr]) = 0) then
        begin{new label}
          a[la][id] := s + 'A';
          a[la][opcode] := i2o(I);
          la := la+1;
        end;{new label}
    end;{find new label}
  for page := pagelow to pagehigh do
    begin{page cycle}
      np := nword*page;
      for I := 0 to nword-1 do
        begin{add opcodes}
          Ip := np+I;
          s := l[instrs][Ip][instr];
          si := l[instrs][Ip][id];
          if pos('A(',s) = 1
            then begin{new label}
                   J := 0;
                   while (si <> a[J][id]) and (J < la) do J := J+1;
                   if J < la
                     then l[instrs][Ip][opcode] := a[J][opcode]
                     else begin{no address}
                            writeln('Error: No label found for ',si);
                            goto 999;
                          end;{no address}
                 end{new label}
            else if pos('VAR=',s) = 1
                   then begin{variable initial value}
                          delete(s,1,4);
                          if constant(s)
                            then l[instrs][Ip][opcode] := c2o(s)
                            else begin{address label}
                                   J := 0;
                                   while (s <> a[J][id]) and (J < la) do 
                                     J := J+1;
                                   if J < la
                                     then l[instrs][Ip][opcode] := a[J][opcode]
                                             else begin{no address}
                                                    write('Error: No label ');
                                                    writeln('found for ',s);
                                                    goto 999;
                                                  end;{no address}
                                 end;{address label}
                        end{variable initial value}
                   else if not(constant(s)) and (s <> 'VAR') and (s <> 'BLANK') 
                          and (s <> 'RTNADR') then
                            begin{instruction}
                              J := 1;
                              while (s[J] <> ' ') and (J <= length(s)) do 
                                J := J+1;
                              st := copy(s,1,J-1);
                              delete(s,1,J);
                              if st = 'AND' then oc := '0'
                              else if st = 'TAD' then oc := '1'
                              else if st = 'INC' then oc := '2'
                              else if st = 'ISZ' then oc := '2'
                              else if st = 'DCA' then oc := '3'
                              else if st = 'JMS' then oc := '4'
                              else if st = 'JMP' then oc := '5'
                              else if st = 'NOP' then oc := '700'
                              else if st = 'IAC' then oc := '701'
                              else if st = 'RAL' then oc := '702'
                              else if st = 'CMA' then oc := '704'
                              else if st = 'CLA' then oc := '710'
                              else if st = 'HLT' then oc := '721'
                              else if st = 'RAR' then oc := '722'
                              else if st = 'SMA' then oc := '724'
                              else if st = 'SZA' then oc := '730'
                              else if st = 'CLA.IAC' then oc := '711'
                              else if st = 'CLA.CMA' then oc := '714'
                              else if st = 'SZA.SMA' then oc := '734'
                              else if st = 'CMA.IAC' then oc := '705'
                              else if st = 'SKF' then oc := '601'
                              else if st = 'SDF' then oc := '621'
                              else if st = 'KRS' then oc := '602'
                              else if st = 'LDS' then oc := '622'
                              else if st = 'RKF' then oc := '604'
                              else if st = 'RDF' then oc := '624'
                              else if st = 'KRB' then oc := '606'
                              else if st = 'LDB' then oc := '626'
                              else begin{invalid instruction}
                                     write('Error: Instruction ',st,' is not ');
                                     write('valid in page ',page:1,' line ');
                                     writeln(I:1,'.');
                                     goto 999;
                                   end;{invalid instruction}
                              case oc[1] of
                                '0'..'5': begin{memory reference instruction}
                                            if pos('I ',s) = 1
                                              then begin{indirect}
                                                     delete(s,1,2);
                                                     ad := 16;
                                                   end{indirect}
                                              else ad := 0;
                                            J := 0;
                                            while (s <> l[instrs][np+J][id]) and 
                                              (J < nword) do J := J+1;
                                            if J < nword
                                              then oc := oc+copy(i2o(ad+J),2,2)
                                              else begin{error}
                                                     write('Error: Address ');
                                                     write('not found for ',s);
                                                     writeln('.');
                                                     goto 999;
                                                   end;{error}
                                          end;{memory reference instruction}
                                '6': begin{IOT instruction}
                                       if s = '1'
                                         then begin{port 1}
                                                if oc[2] = '0'
                                                  then oc[2] := '1'
                                                  else oc[2] := '3';
                                              end{port 1}
                                         else if s <> '0' then
                                                begin{invalid port}
                                                  write('Error: IOT port ',s);
                                                  writeln(' is not valid.');
                                                  goto 999;
                                                end;{invalid port}
                                     end;{IOT instruction}
                              end;{extended case}
                              l[instrs][Ip][opcode] := oc;
                            end;{instruction}
        end;{add opcodes}
    end;{page cycle}
end;{insert opcodes}

procedure writeinstr(line:linetype);
var J,wl:integer;
begin{write instr line}
  wl := length(line[id]);
  if wl > 0 then
    begin{write id}
      write(outfile,line[id],',');
      wl := wl+1;
    end;{write id}
  for J := 0 to idlength-wl-1 do
    write(outfile,' ');
  write(outfile,line[instr]);
  for J := 0 to instrlength-length(line[instr])-1 do
    write(outfile,' ');
  if length(line[opcode]) > 0
    then write(outfile,line[opcode])
    else write(outfile,'   ');
  if length(line[comment]) > 0
    then write(outfile,' /',line[comment]);
  writeln(outfile);
end;{write instr line}

procedure write_code;
var I,page,np:integer;
begin{write code}
{  for I := 0 to cnt[vars]-1 do
    writeinstr(l[vars][I]);
  writeln(outfile);
  for I := 0 to cnt[consts]-1 do
    writeinstr(l[consts][I]);
  writeln(outfile);}
  for page := pagelow to pagehigh do
    begin{write page}
      np := nword*page;
      writeln(outfile,'/',page:1);
      for I := 0 to word[instrs][page]-1 do
        begin{write words}
{          if I = constpos[page] then
            writeln(outfile);}
          write(outfile,i2o(np+I),' ');
          writeinstr(l[instrs][nword*page+I])
        end;{write words}
    end;{write page}
end;{write code}

begin{main}
  writeln('e8asy version ',version:4:2,' ',date);
  write('Input filename: ');
  readln(filename);
  assign(infile,filename + '.txt');
  reset(infile);
  read_code;
  find_constpos;
  insert_arrays_tables;
  insert_indirect_variables;
  insert_variables_constants;
  insert_opcodes;
  assign(outfile,filename + '.asy');
  rewrite(outfile);
  write_code;
  close(outfile);
  999:
  close(infile);
end.{main}